C+    getfoldlocusstart.f
C This file was written by Jonathan A. Sherratt
C Copyright (C) 2011 Heriot-Watt University, Edinburgh, UK
C  
C THIS FILE IS PART OF WAVETRAIN.
C WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
C AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
C HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
C THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
C THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
C WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
C THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
C OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
C http://www.netlib.org/blas/faq.html#2;
C http://www.netlib.org/lapack/#_licensing; 
C http://www.netlib.org/minpack/disclaimer.
C 
C PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
C COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
C SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
C 
C DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
C A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
C PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
C UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
C PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
C INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
C 
C WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
C THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
C TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
C FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
C LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
C DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
C OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
C ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
C LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
C OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
C RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS SOFTWARE 
C WILL BE ERROR-FREE.
C  
C+    THIS PROGRAM READS IN OUTPUT FROM THE AUTO RUN 
C+    THAT GENERATES STARTING DATA FOR A CONTINUATION OF A 
C+    FOLD IN THE BRANCH OF PERIODIC TRAVELLING WAVE SOLUTIONS. 
C+    IT THEN WRITES THE LABEL NUMBER FOR THE NEW STARTING 
C+    POINT TO A FILE.
C+    NOTE THAT THERE IS NO NEED TO TEST FOR CONVERGENCE 
C+    BECAUSE THE PROGRAM convergencetest.f (IN ../spectrum) 
C+    IS RUN PRIOR TO THIS PROGRAM.
C++
      IMPLICIT REAL*8 (A-H,K,O-Z)
      CALL GINFO(INFO)
      OPEN(11,FILE='../temp_files/defaults.input'
     &,STATUS='OLD')
      REWIND(11)
      READ(11,*)
      READ(11,*)
      READ(11,*)
      READ(11,*)NMXHB,NMXPTW,NMXBD,NMXSP,NMXSB,NMXDUM
      CLOSE(11)
      OPEN(12,FILE='fort.7'
     &,STATUS='OLD')
      REWIND(12)
      DO 600 I=1,12
         READ(12,*,END=102)
 600  CONTINUE
      READ(12,*,END=102)IDUMMY,IPT,ITY,ILAB
      DO 100 I=1,NMXPTW
         READ(12,*,END=101)IDUMMY,IPT,ITY,ILAB
 100  CONTINUE
      OPEN(66,FILE='../temp_files/fortran.error'
     &,STATUS='NEW')
      WRITE(66,'(''ERROR: END OF LOOP 100'')')
      WRITE(66,'(''       getfoldlocusstart.f'')')
      CLOSE(66)
      CLOSE(12)
      CALL ISTOP(INFO)
 101  CONTINUE
      OPEN(19,FILE='../temp_files/foldlocuslabel.data'
     &,STATUS='NEW')
      WRITE(19,'(I8)')ILAB
      CLOSE(19)
      CALL ISTOP(INFO)
 102  CONTINUE
      OPEN(66,FILE='../temp_files/fortran.error'
     &,STATUS='NEW')
      WRITE(66,'(''ERROR: IN getfoldlocusstart.f'')')
      WRITE(66,'(''       LESS THAN 13 LINES IN fort.7'')')
      CLOSE(66)
      CLOSE(12)
      CALL ISTOP(INFO)
      END
